<?PHP
/**
* @class 출석부 모듈의 attendanceController 클래스
* @author 매실茶 (pppljh@gmail.com)
* @JS필터를 통해 요청된 작업 수행
*
* 출석부 기록, 관리자의 임의 출석내용 변경 시 호출되는 함수들이 있습니다.
**/

class attendanceController extends attendance {

    /**
    * @brief 초기화
    **/
	function init(){
	}

    /**
    * @brief 출석부 기록
    **/
    function procAttendanceInsertAttendance() {

	    /*attendance model 객체 생성*/
	    $oAttendanceModel = &getModel('attendance');
        $obj = Context::getRequestVars();
	    $oAttendanceModel->insertAttendance($obj->about_position, $obj->greetings);
    }

    /**
    * @brief 출석부 설정값 등록
    **/
	//출석부 설정값 등록 함수
	function procAttendanceInsertConfig(){
		if(date('t', mktime(0,0,0,02,1,zDate(date('YmdHis'),"Y")))==29)
			$end_of_year = 366;
		else
			$end_of_year = 365;
        $end_of_month = date('t', mktime(0,0,0,zDate(date('YmdHis'),"m"),1,zDate(date('YmdHis'),"Y")));
		$output = executeQuery('attendance.isExistConfig',$arg);
        //관리자 출석부분 부터는 모듈 설정 기능을 사용.
        $oModuleController = &getController('module');
		//설정값이 저장되어있지 않다면
		if((int)$output->data->count == 0){
			$obj = Context::getRequestVars();
            $obj->start_time = sprintf("%02d%02d",$obj->start_hour,$obj->start_min);
            $obj->end_time = sprintf("%02d%02d",$obj->end_hour,$obj->end_min);
            if($obj->continuity_day < 2){ $obj->continuity_day = 2; }
            if($obj->diligence_yearly >= $end_of_year || $obj->diligence_yearly < 32) { $obj->diligence_yearly = $end_of_year - 1; }
            if($obj->diligence_monthly >= $end_of_month || $obj->diligence_monthly < 8) { $obj->diligence_monthly = $end_of_month - 1; }
            if($obj->diligence_weekly >= 7 || $obj->diligence_weekly < 1) { $obj->diligence_weekly = 6; }
            $config->about_admin_check = $obj->about_admin_check;
            $oModuleController->insertModuleConfig('attendance', $config);
			executeQuery("attendance.insertConfig", $obj);
		}else{
			$obj = Context::getRequestVars();
            if($obj->continuity_day < 2){ $obj->continuity_day = 2; }
            if($obj->diligence_yearly >= $end_of_year || $obj->diligence_yearly < 32) { $obj->diligence_yearly = $end_of_year - 1; }
            if($obj->diligence_monthly >= $end_of_month || $obj->diligence_monthly < 8) { $obj->diligence_monthly = $end_of_month - 1; }
            if($obj->diligence_weekly >= 7 || $obj->diligence_weekly < 1) { $obj->diligence_weekly = 6; }
            $obj->start_time = sprintf("%02d%02d",$obj->start_hour,$obj->start_min);
            $obj->end_time = sprintf("%02d%02d",$obj->end_hour,$obj->end_min);
            $config->about_admin_check = $obj->about_admin_check;
            $oModuleController->insertModuleConfig('attendance', $config);
			executeQuery("attendance.updateConfig", $obj);
		}
		
	}

    /**
    * @brief 관리자 임의 출석 제거
    **/
	function procAttendanceDeleteData(){

		//포인트 모듈 연동
        $oPointController = &getController('point');

		/*attendance model 객체 생성*/
		$oAttendanceModel = &getModel('attendance');

		//넘겨받고
		$obj = Context::getRequestVars();
		$year = substr($obj->check_day,0,4);
		$year_month = substr($obj->check_day,0,6);
		$args->check_day = $obj->check_day;
		$args->member_srl = $obj->member_srl;

        $oMemberModel = &getModel('member');
        $member_info = $oMemberModel->getMemberInfoByMemberSrl($obj->member_srl);

        /*출석당일 포인트 꺼내오기*/
        $daily_info = $oAttendanceModel->getUserAttendanceData($member_info->member_srl, $obj->check_day);

		/*각종 포인트 설정값 꺼내오기*/
		$output = executeQuery('attendance.getConfigData');
		$config_data = $output->data;

		if($oAttendanceModel->getIsCheckedA($obj->member_srl, $obj->check_day)!=0){

            //포인트도 감소
            $oPointController->setPoint($member_info->member_srl, $daily_info->today_point, 'minus');

		    //출석기록에서 제거(쿼리 수행)
		    executeQuery("attendance.deleteAttendanceData", $args);

		    /*기록될 날짜!!*/
		    $regdate =  sprintf("%s235959",$obj->check_day);
		    $continuity->data = 1;
		    $continuity->point = 0;
		    //총 출석데이터 갱신
		    if($oAttendanceModel->isExistTotal($obj->member_srl) == 0){
			    /*총 출석횟수 계산*/
			    $total_attendance = $oAttendanceModel->getTotalAttendance($obj->member_srl);
			    /*총 출석 기록*/
			    $oAttendanceModel->insertTotal($obj->member_srl, $continuity, $total_attendance, 0, $regdate);
		    }else{
			    /*총 출석횟수 계산*/
			    $total_attendance = $oAttendanceModel->getTotalAttendance($obj->member_srl);
			    /*총 출석포인트 받아오기*/
			    $total_point = $oAttendanceModel->getTotalPoint($obj->member_srl);
                $total_point -= $daily_info->today_point;
                if($total_point < 0) { $total_point = 0; }
			    /*총 출석 기록*/
			    $oAttendanceModel->updateTotal($obj->member_srl, $continuity, $total_attendance, $total_point, $regdate);
		    }

		    //연간 출석데이터 갱신
		    if($oAttendanceModel->isExistYearly($obj->member_srl, $year) == 0){	//연간 데이터가 없으면
			    /*올 해 출석횟수 계산*/
			    $yearly_data = $oAttendanceModel->getYearlyData($year, $obj->member_srl);
			    /*연간출석데이터 추가*/
			    $oAttendanceModel->insertYearly($obj->member_srl, $yearly_data, 0, $regdate);
		    }else{
			    /*올 해 출석횟수 계산*/
			    $yearly_data = $oAttendanceModel->getYearlyData($year, $obj->member_srl);
			    /*출석 포인트는 예전 자료 꺼내기*/
			    $year_info = $oAttendanceModel->getYearlyAttendance($obj->member_srl, $year);
			    $yearly_point = $year_info->yearly_point;
                $yearly_point -= $daily_info->today_point;
                if($yearly_point <0 ) { $yearly_point = 0; }
			    /*연간출석데이터 업데이트*/
			    $oAttendanceModel->updateYearly($obj->member_srl, $year, $yearly_data, $yearly_point, $regdate);
		    }

		    //월간 출석데이터 갱신
		    if($oAttendanceModel->isExistMonthly($obj->member_srl, $year_month) == 0){	//월간 데이터가 없으면
			    /*이달 출석횟수 계산*/
			    $monthly_data = $oAttendanceModel->getMonthlyData($year_month, $obj->member_srl);
			    /*월간출석데이터 추가*/
			    $oAttendanceModel->insertMonthly($obj->member_srl, $monthly_data, 0, $regdate);
		    }else{
			    /*이달 출석횟수 계산*/
			    $monthly_data = $oAttendanceModel->getMonthlyData($year_month, $obj->member_srl);
			    /*출석 포인트는 예전 자료 꺼내기*/
			    $month_info = $oAttendanceModel->getMonthlyAttendance($obj->member_srl, $year_month);
			    $monthly_point = $month_info->monthly_point;
                $monthly_point -= $daily_info->today_point;
                if($monthly_point < 0) { $monthly_point = 0; }
			    /*월간출석데이터 업데이트*/
			    $oAttendanceModel->updateMonthly($obj->member_srl, $year_month, $monthly_data, $monthly_point, $regdate);
		    }

		    //주간 출석데이터 갱신
		    $week = $oAttendanceModel->getWeek($obj->check_day);
		    if($oAttendanceModel->isExistWeekly($obj->member_srl, $week) == 0 ){	//주간 데이터가 없으면
			    /*이번 주 출석 횟수 계산*/
			    $weekly_data = $oAttendanceModel->getWeeklyAttendance($obj->member_srl, $week);
			    /*주간 출석데이터 추가*/
			    $oAttendanceModel->insertWeekly($obj->member_srl, $weekly_data, 0, $regdate);
		    }else{
			    /*이번 주 출석 횟수 계산*/
			    $weekly_data = $oAttendanceModel->getWeeklyAttendance($obj->member_srl, $week);
			    /*출석 포인트는 예전자료 꺼내기*/
			    $week_info = $oAttendanceModel->getWeeklyData($obj->member_srl, $week);
			    $weekly_point = $week_info->weekly_point;
                $weekly_point -= $daily_info->today_point;
                if($weekly_point < 0){ $weekly_point = 0; }
			    /*주간 출석데이터 업데이트*/
			    $oAttendanceModel->updateWeekly($obj->member_srl, $week, $weekly_data, $weekly_point, $regdate);	
		    }
            $this->setMessage("success_deleted");
        }
	}

    /**
    * @brief 관리자 임의 출석 기록
    **/
	function procAttendanceCheckData(){

		//포인트 모듈 연동
        $oPointController = &getController('point');

		/*attendance model 객체 생성*/
		$oAttendanceModel = &getModel('attendance');

		//넘겨받고
        $obj = Context::getRequestVars();
		$year = substr($obj->check_day,0,4);
		$year_month = substr($obj->check_day,0,6);
		$args->check_day = $obj->check_day;
		$args->member_srl = $obj->member_srl;

        $oMemberModel = &getModel('member');
        $member_info = $oMemberModel->getMemberInfoByMemberSrl($obj->member_srl);

		/*각종 포인트 설정값 꺼내오기*/
		$output = executeQuery('attendance.getConfigData');
		$config_data = $output->data;
        $obj->today_point = $config_data->add_point;

		if($oAttendanceModel->getIsCheckedA($obj->member_srl, $obj->check_day)==0){

            /*기록될 날짜!!*/
			$regdate = sprintf("%s235959",$obj->check_day);
            $year = substr($obj->check_day,0,4);
            $year_month = substr($obj->check_day,0,6);
			$week = $oAttendanceModel->getWeek($obj->check_day);

			/*지정일 포인트 지급*/
			if($config_data->about_target == 'yes'){
				if($obj->check_day == $config_data->target_day){
					$obj->today_point += $config_data->target_point;
				}
			}

			/*개근포인트 지급*/
			$about_perfect = $oAttendanceModel->isPerfect($obj->member_srl, $obj->check_day, false);
			if($about_perfect->yearly_perfect == 1){
				$obj->today_point += $config_data->yealy_point;
			}
			if($about_perfect->monthly_perfect == 1){
				$obj->today_point += $config_data->monthly_point;
			}
			$weekly_data = $oAttendanceModel->getWeeklyData($obj->member_srl, $week);
			if($weekly_data->weekly == 6 && $obj->check_day==$week->sunday){
				$obj->today_point += $config_data->weekly_point;
			}

            /*정근포인트 관련 추가*/
            if($config_data->about_diligence_yearly == 'yes'){
                if($oAttendanceModel->checkYearlyDiligence($obj->member_srl, $config_data->diligence_yearly-1, $year) == 1){
                    $obj->today_point += $config_data->diligence_yearly_point;
                }
            }
            if($config_data->about_diligence_monthly == 'yes'){
                if($oAttendanceModel->checkMonthlyDiligence($obj->member_srl, $config_data->diligence_monthly-1, $year_month) == 1){
                    $obj->today_point += $config_data->diligence_monthly_point;
                }
            }
            if($config_data->about_diligence_weekly == 'yes'){
                if($oAttendanceModel->checkWeeklyDiligence($obj->member_srl, $config_data->diligence_weekly-1, $obj->check_day) == 1){
                    $obj->today_point += $config_data->diligence_weekly_point;
                }
            }

			$args->regdate = $regdate;
			$args->attendance_srl = getNextSequence();
			$args->greetings="^admin_checked^";
			$args->today_point = $obj->today_point;

			//출석부에 기록(쿼리 수행)
			executeQuery("attendance.insertAttendance", $args);

            //포인트도 기록
            $new_point += $obj->today_point;
            $oPointController->setPoint($member_info->member_srl,$obj->today_point, 'add');

			//총 출석데이터 갱신
			if($oAttendanceModel->isExistTotal($obj->member_srl) == 0){
				/*총 출석횟수 계산*/
				$total_attendance = $oAttendanceModel->getTotalAttendance($obj->member_srl);
			    $continuity->data = 1;
			    $continuity->point = 0;
				/*총 출석 기록*/
				$oAttendanceModel->insertTotal($obj->member_srl, $continuity, $total_attendance, $obj->today_point, $regdate);
			}else{
				/*총 출석횟수 계산*/
				$total_attendance = $oAttendanceModel->getTotalAttendance($obj->member_srl);
				/*총 출석포인트 받아오기*/
				$total_point = $oAttendanceModel->getTotalPoint($obj->member_srl);
                $total_point += $obj->today_point;
			    $continuity->data = null;
			    $continuity->point = 0;
				/*총 출석 기록*/
				$oAttendanceModel->updateTotal($obj->member_srl, $continuity=null, $total_attendance, $total_point, $regdate);
			}

			//연간 출석데이터 갱신
			if($oAttendanceModel->isExistYearly($obj->member_srl, $year) == 0){	//연간 데이터가 없으면
				/*올 해 출석횟수 계산*/
				$yearly_data = $oAttendanceModel->getYearlyData($year, $obj->member_srl);
				/*연간출석데이터 추가*/
				$oAttendanceModel->insertYearly($obj->member_srl, $yearly_data, $obj->today_point, $regdate);
			}else{
				/*올 해 출석횟수 계산*/
				$yearly_data = $oAttendanceModel->getYearlyData($year, $obj->member_srl);
				/*출석 포인트는 예전 자료 꺼내기*/
				$year_info = $oAttendanceModel->getYearlyAttendance($obj->member_srl, $year);
				$yearly_point = $year_info->yearly_point;
                $yearly_point += $obj->today_point;
				/*연간출석데이터 업데이트*/
				$oAttendanceModel->updateYearly($obj->member_srl, $year, $yearly_data, $yearly_point, $regdate);
			}

			//월간 출석데이터 갱신
			if($oAttendanceModel->isExistMonthly($obj->member_srl, $year_month) == 0){	//월간 데이터가 없으면
				/*이달 출석횟수 계산*/
				$monthly_data = $oAttendanceModel->getMonthlyData($year_month, $obj->member_srl);
				/*월간출석데이터 추가*/
				$oAttendanceModel->insertMonthly($obj->member_srl, $monthly_data, $obj->today_point, $regdate);
			}else{
				/*이달 출석횟수 계산*/
				$monthly_data = $oAttendanceModel->getMonthlyData($year_month, $obj->member_srl);
				/*출석 포인트는 예전 자료 꺼내기*/
				$month_info = $oAttendanceModel->getMonthlyAttendance($obj->member_srl, $year_month);
				$monthly_point = $month_info->monthly_point;
                $monthly_point += $obj->today_point;
				/*월간출석데이터 업데이트*/
				$oAttendanceModel->updateMonthly($obj->member_srl, $year_month, $monthly_data, $monthly_point, $regdate);
			}

			//주간 출석데이터 갱신
			if($oAttendanceModel->isExistWeekly($obj->member_srl, $week) == 0 ){	//주간 데이터가 없으면
				/*이번 주 출석 횟수 계산*/
				$weekly_data = $oAttendanceModel->getWeeklyAttendance($obj->member_srl, $week);
				/*주간 출석데이터 추가*/
				$oAttendanceModel->insertWeekly($obj->member_srl, $weekly_data, $obj->today_point, $regdate);
			}else{
				/*이번 주 출석 횟수 계산*/
				$weekly_data = $oAttendanceModel->getWeeklyAttendance($obj->member_srl, $week);
				/*출석 포인트는 예전자료 꺼내기*/
				$week_info = $oAttendanceModel->getWeeklyData($obj->member_srl, $week);
				$weekly_point = $week_info->weekly_point;
                $weekly_point +=$obj->today_point;
				/*주간 출석데이터 업데이트*/
				$oAttendanceModel->updateWeekly($obj->member_srl, $week, $weekly_data, $weekly_point, $regdate);	
			}
            $this->setMessage("등록되었습니다.");
		}
	}
}
?>
